<?php
/*
v1.1
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LJProxy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
	$DO_CACHE = true;
	$CACHE_TIME = 60 /* seconds */ * 60 /* minutes */;
	$mode = isset($_REQUEST['mode']) ? $_REQUEST['mode'] : '';
	if (strcmp($mode, "rss") != 0)
	{
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
	"http://www.w3.org/TR/html4/strict.dtd">
<html><head>
	<title>LJProxy v1.1</title>
</head><body>
<?php
	}
	require_once('ljrss.php');
	$password = isset($_REQUEST['password']) ? $_REQUEST['password'] : '';
	$key = isset($_REQUEST['key']) ? $_REQUEST['key'] : '';
	$pwd = isset($_REQUEST['pwd']) ? $_REQUEST['pwd'] : '';
	$group = isset($_REQUEST['group']) ? $_REQUEST['group'] : '';
	$loggedIn = false;
	if ( (strcmp($mode, "list") == 0) && (strcmp($pwd, $LJ_PASSWORD) == 0) )
	{
		$loggedIn = true;
		$ljRpc = new LiveJournalRpc();
		$ljRpc->login($LJ_USERNAME, $LJ_PASSWORD);
		$groupNames = $ljRpc->getFriendGroupNames();
		print("<h1>LJProxy v1.1 RSS List</h1>\n");
		print("You may right-click on any of the subscribe links, below, use your browser's context menu to copy the link location, then paste that into Google Reader as the feed URL.");
		print("<ul>");
		for ($i = 0; $i < sizeof($groupNames); $i++)
		{
			$groupName = $groupNames[$i];
			if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'])
				$url = 'https://' . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . '?mode=rss&key=' . urlencode($PASS_KEY) . '&group=' . urlencode($groupName);
			else
				$url = 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . '?mode=rss&key=' . urlencode($PASS_KEY) . '&group=' . urlencode($groupName);
			print("<li>" . $groupName . " - <a href=\"" . $url . "\">" . $url . "</a><br />\n");
			$members = $ljRpc->getMembersOfGroup($groupNames[$i]);
			for ($j = 0; $j < sizeof($members); $j++)
				print($members[$j] . " ");
			print("<br />\n<br />\n");
			print("</li>\n");
		}
		print("</ul>\n");
	}
	if ( (strcmp($mode, "rss") == 0) && (strcmp($key, $PASS_KEY) == 0) )
	{
		$loggedIn = true;
		$filename = LiveJournalRpc::sanitizeGroupName($group) . '-' . $PASS_KEY . '.xml';
		header("Content-type: text/xml");
		if ($DO_CACHE)
		{
			if (file_exists($filename))
			{
				$createTime = filemtime($filename);
				if (time() - $CACHE_TIME < $createTime)
				{
					readfile($filename);
					exit();
				}
			}
		}
		$ljRpc = new LiveJournalRpc();
		$ljRpc->login($LJ_USERNAME, $LJ_PASSWORD);
		$ljRpc->makeRss($group, $filename);
		readfile($filename);
		exit();
	}
	if (strcmp($mode, "testgetentries") == 0)
	{
		$ljRpc = new LiveJournalRpc();
		$ljRpc->login($LJ_USERNAME, $LJ_PASSWORD);
		$ljRpc->testGetEntries('feedle');
		exit();
	}
	
	
	if (!$loggedIn)
	{
		?>
			<h1>LJProxy v1.1 Login</h1>
			Please provide your LiveJournal login credentials below to get a list of your
			friend group RSS feeds.
			<form method="post">
			<input type="hidden" name="mode" value="list" />
			<table align="center">
			<tr><td>Username:</td><td><?php print($LJ_USERNAME); ?></td></tr>
			<tr><td>Password:</td><td><input type="password" name="pwd" /></td></tr>
			<tr><td></td><td><input type="submit" value="Login" /></td></tr>
			</table>
			</form>
			<script type="text/javascript">
			document.forms[0].elements['pwd'].focus();
			</script>
		<?php
	}
	// testLogin();
?>
</body></html>